<?php
/***************************************************** 
 *         System biblioteczny - Modul OPAC          * 
 ***************************************************** 
 * Wersja: 1.02 Stable                               * 
 * Data: 20.02.2009 (16:48)                          * 
 * Autor: Jacek Kowalski (http://jacekk.info)        * 
 *                                                   * 
 * Utwor rozprowadzany na licencji                   * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/ * 
 *****************************************************/

class ksiazki {
	static $LT_API = '';
	
	static $cache = array();
	
	static function okladka($KOD, $ISBN) {
		if(!function_exists('curl_init')) {
			return FALSE;
		}
		
		if(strlen($ISBN)==13) {
			validate::EAN($ISBN);
			
			if(substr($ISBN, 0, 3)=='978') {
				$ISBN10 = convert::ISBN13_to_ISBN10($ISBN);
			}
			else
			{
				$ISBN10 = $ISBN;
			}
		}
		elseif(strlen($KOD)<=8 && ctype_digit($KOD)) {
			validate::KOD($KOD);
			
			if(!file_exists('./covers/own/'.$KOD)) {
				return FALSE;
			}
			else
			{
				return './covers/own/'.$KOD;
			}
		}
		else
		{
			return FALSE;
		}
		
		if(file_exists('./covers/own/'.$ISBN)) {
			return './covers/own/'.$ISBN;
		}
		elseif(!file_exists('./covers/'.$ISBN) || (filesize('./covers/'.$ISBN)==0 AND filemtime('./covers/'.$ISBN)+2592000 < time())) {
			$get = 'http://www.librarything.com/devkey/'.self::$LT_API.'/small/isbn/'.$ISBN10;
			$curl = curl_init($get);
			curl_setopt($curl, CURLOPT_FOLLOWLOCATION, TRUE);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
			
			$img = @curl_exec($curl);
			$code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
			$type = curl_getinfo($curl, CURLINFO_CONTENT_TYPE);
			if($code != 200 || substr($type, 0, 6) != 'image/' || $img == FALSE || strlen($img) < 100) {
				touch('./covers/'.$ISBN);
				return FALSE;
			}
			else
			{
				file_put_contents('./covers/'.$ISBN, $img);
				return './covers/'.$ISBN;
			}
		}
		elseif(file_exists('./covers/'.$ISBN) AND filesize('./covers/'.$ISBN)>100) {
			return './covers/'.$ISBN;
		}
		
		return FALSE;
	}
	
	static function okladka_big($KOD, $ISBN) {
		if(!function_exists('curl_init')) {
			return FALSE;
		}
		
		if(strlen($ISBN)==13) {
			validate::EAN($ISBN);
			
			if(substr($ISBN, 0, 3)=='978') {
				$ISBN10 = convert::ISBN13_to_ISBN10($ISBN);
			}
			else
			{
				$ISBN10 = $ISBN;
			}
		}
		elseif(strlen($KOD)<=8 && ctype_digit($KOD)) {
			validate::KOD($KOD);
			
			if(!file_exists('./covers_big/own/'.$KOD)) {
				return FALSE;
			}
			else
			{
				return './covers_big/own/'.$KOD;
			}
		}
		else
		{
			return FALSE;
		}
		
		if(file_exists('./covers_big/own/'.$ISBN)) {
			return './covers_big/own/'.$ISBN;
		}
		elseif((file_exists('./covers/'.$ISBN) && !file_exists('./covers_big/'.$ISBN)) || (file_exists('./covers_big/'.$ISBN) AND filesize('./covers_big/'.$ISBN)==0 AND filemtime('./covers_big/'.$ISBN)+2592000 < time())) {
			$get = 'http://www.librarything.com/devkey/'.self::$LT_API.'/large/isbn/'.$ISBN10;
			$curl = curl_init($get);
			curl_setopt($curl, CURLOPT_FOLLOWLOCATION, TRUE);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
			
			$img = curl_exec($curl);
			$code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
			$type = curl_getinfo($curl, CURLINFO_CONTENT_TYPE);
			if($code != 200 || substr($type, 0, 6) != 'image/' || $img == FALSE || strlen($img) < 100) {
				touch('./covers_big/'.$ISBN);
				return FALSE;
			}
			else
			{
				file_put_contents('./covers_big/'.$ISBN, $img);
				return './covers_big/'.$ISBN;
			}
		}
		elseif(file_exists('./covers_big/'.$ISBN) AND filesize('./covers_big/'.$ISBN)>100) {
			return './covers_big/'.$ISBN;
		}
		return FALSE;
	}
	
	static function exists($kod) {
		$info = self::cache_get($kod);
		if(isset($info['id'])) {
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	
	static function cache_get($kod) {
		$kod = (int)$kod;
		if(!isset(self::$cache[$kod])) {
			self::cache_update($kod);
		}
		
		return self::$cache[$kod];
	}
	
	static function cache_add($kod, &$dane) {
		if($dane['od2']) {
			$dane['od'] = $dane['od2'];
			unset($dane['od2']);
		}
		self::$cache[(int)$kod] = $dane;
	}
	
	static function cache_addarray(&$dane) {
		foreach($dane as &$r) {
			self::cache_add($r['id'], $r);
		}
	}
	
	static function cache_clear($id=NULL) {
		if(is_null($id)) {
			self::$cache = array();
		}
		else
		{
			unset(self::$cache[$id]);
		}
	}
	
	static function cache_update($kod) {
		self::cache_add($kod, sql::fetchone(sql::query('SELECT *, (SELECT MAX(`od`) FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id`) as `od2`, (SELECT `do` FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id` AND `od`=`od2`) as `do` FROM `ksiazki` WHERE `id`=\''.sql::escape($kod).'\'')));
	}
	
	static function szukaj_KOD($kod) {
		validate::KOD($kod, TRUE);
		
		return self::cache_get($kod);
	}
	
	static function szukaj_info($dane, $order, $start=NULL, $limit=30) {
		$allow = array('id', 'tytul', 'autor', 'wydawnictwo', 'miejsce', 'rok', 'wydanie');
		$replace = array('tytul' => 'tytul~~', 'autor' => 'autor~~', 'wydawnictwo' => 'wydawnictwo~~');
		
		$where = array();
		
		foreach($dane as $key => $value) {
			if(!in_array($key, $allow) OR $value==='') {
				continue;
			}
			
			if($replace[$key]) {
				$key = $replace[$key];
			}
			
			$where[$key] = $value;
		}
		
		if($where['id']) {
			validate::$kod = TRUE;
			switch(validate::type($where['id'])) {
				case 'ISBN':
					$where['ISBN'] = $where['id'];
					unset($where['id']);
				break;
				case 'ISSN':
					$where['ISBN'] = $where['id'];
					unset($where['id']);
				break;
				case 'MSC':
					$where['regal'] = $where['id'];
					$where['polka'] = $dane['polka'];
					$where['rzad'] = $dane['rzad'];
					unset($where['id']);
				break;
			}
			validate::$kod = FALSE;
		}
		
		if(!$where['regal']) {
			unset($where['polka']);
			unset($where['rzad']);
		}
		
		if($where['id']) {
			$ret[] = self::szukaj_KOD($where['id']);
			$num = count($ret);
		}
		else
		{
			$num = db2::num('ksiazki', 'id', $where);
			$ret = sql::fetch(sql::query('SELECT *, (SELECT MAX(`od`) FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id`) as `od2`, (SELECT `do` FROM `pozycz` WHERE `pozycz`.`id`=`ksiazki`.`id` AND `od`=`od2`) as `do` FROM `ksiazki`'.db2::__combine_where($where).db2::__combine_order($order).db2::__combine_limit($start, $limit)));
			
			self::cache_addarray($ret);
		}
		
		return array($num, $ret, db2::revelance());
	}
}
?>
